import { request } from 'umi';

/** 获取设备列表  */
export async function GetDeviceInfoPage(data) {
  return request(`/kitchen/api/TestDevices/GetDeviceInfoPage`, {
    method: 'POST',
    data: data,
  });
}
/**获取设备类型 */
export async function GetDicList(TypeCode) {
  return request(`/kitchen/api/dict-data/dic-list/${TypeCode}`, {
    method: 'Get',
  });
}
/** 添加设备  */
export async function AddDeviceInfo(data) {
  return request(`/kitchen/api/TestDevices/AddDeviceInfo`, {
    method: 'POST',
    data: data,
  });
}

/** 修改  */
export async function UpdateDeviceInfo(data) {
  return request(`/kitchen/api/TestDevices/UpdateDevice`, {
    method: 'POST',
    data: data,
  });
}

/** 删除  */
export async function DelDeviceInfo(data) {
  return request(`​​/kitchen/api/TestDevices/DelDeviceInfo`, {
    method: 'POST',
    data: data,
  });
}
/** 获取所有设备类型  */
export async function GetDeviceType(data) {
  return request(`​/kitchen/api/Device/GetDeviceType`, {
    method: 'GET',
  });
}

/** 获取所有设备版本  */
export async function GetDeviceVersions() {
  return request(`​/kitchen/api/Device/GetDeviceVersions`, {
    method: 'post',
  });
}

/**
 * 获取当前设备绑定的商品
 * @param {*} params 
 * @param {*} options 
 * @returns 
 */
export async function GetDeviceGoods(params, options) {
  return request('/kitchen/api/Device/GetDeviceGoods', {
    method: 'POST',
    data: {
      ...params,
    },
  });
}




