import { PlusOutlined, UploadOutlined,ArrowLeftOutlined,DeleteOutlined } from '@ant-design/icons';
import { Button, Card, message, Steps, Empty, Form, Input, Upload, Select, InputNumber, Switch } from 'antd';
import { GridContent, PageContainer, RouteContext } from '@ant-design/pro-layout';
import React, { Fragment, useRef, useState, useEffect } from 'react';
import classNames from 'classnames';
import ProTable from '@ant-design/pro-table';
import GoodsbomFrom from './components/GoodsbomFrom';
import CreateBom from './components/CreateBom';
import GoodsTechnologyMaken from './components/goodstechnologymaken'
import { addGoods, goodsType, goodsbigType, getgoodsTaste } from '../newgoods/service';
import { GetGoodsBom, AddBomApi, DelGoodsBom, GetCosRequestURL, unitList,getbygoodsidattribute,addgoodsbomattribute,getbomtypepage,getproductpage,GetAliyunRequestURL } from './service'
import axios from 'axios';
import { history } from 'umi';

const { Step } = Steps;
const { Option, OptGroup } = Select;
const { TextArea } = Input;
const Advanced = (props) => {
  const [form] = Form.useForm();
  const [goodsTypes, setGoodsTypes] = useState([]);
  const [goodsUnit, setGoodsUnit] = useState([]);
  const [goodsBigTypes, setGoodsBigTypes] = useState([]);
  const [goodsTaste, setGoodsTaste] = useState([]);
  const [setGoodsBomModalVisible, handleGoodsBomModalVisible] = useState();
  const [handleCreateoodsBomModalVisible,setHandleCreateoodsBomModalVisible] = useState(false);
  const [selectedRowsState, setSelectedRows] = useState([]);
  const actionRef = useRef();
  const [currTabKey, SetCurrTabKey] = useState("basis")
  const [url, setUrl] = useState(props.location.query.values ? props.location.query.values.imgUrl : null);
  const [currentGoodsProp, setCurrentGoodsProp] = useState(0);
  const [goodsAttriburteData, setGoodsAttriburteData] = useState([]);
  const [bomtype, setBomtype] = useState([]);
  const [matedata, setMatedata] = useState([]);
  const [hovered, setHovered] = useState(false);
  
  //事件
  const onFinish = async (values) => {
    const hide = message.loading('正在添加');
    console.log(values)
    try {
      if(props.location.query.isAdd){
        values.id=null;
      }
      values.imgUrl = url;
      if(values.defaultMate){
        values.defaultMate=values.defaultMate.join();
      }else{
        values.defaultMate="";
      }
      
      await addGoods(JSON.stringify(values)).then((r) => {
        if (r.data) {
          if(values.id){
            message.success('更新成功');
          }else{
            message.success('添加成功');
          }
          history.push({
            pathname: '/goods/newgoods',
          });
        } else {
          message.error(r.errors);
        }
      });
      hide();
      return true;
    } catch (error) {
      hide();
      message.error('添加失败请重试！');
      return false;
    }
  };
  const uploadProp = {
    customRequest({
      file,
    }) {
      GetAliyunRequestURL({ directory: "kerp/test/goods", buildUniqueDirectory: false }).then((res) => {
        if (res.success_Action_Status == 200) {
          var formData = new FormData(); //注意formData里append添加的键的大小写
          formData.append("name", file.name); //文件名
          formData.append("key", res.key); //存储在oss的文件路径
          formData.append("ossAccessKeyId", res.ossAccessKeyId); //accessKeyId
          formData.append("policy", res.policy); //policy
          formData.append("signature", res.signature); //签名 //如果是base64文件，那么直接把base64字符串转成blob对象进行上传就可以了
          formData.append("file", file);
          formData.append("success_Action_Status", 200); //成功后返回的操作码
          formData.append("host", res.host);
          fetch(res.host, {
            method: "POST",
            body: formData,
          })
            .then((response) => {
              if (response.ok) {
                let s = `${res.host}/${res.key.replace("${filename}", file.name)}`;
                setUrl(s);
              } // 如果服务器返回 JSON 数据
            })
            .catch((error) => {
              message.error("上传失败：", error);
            });
        }
      })
    }
  };
  const handleDeleteImage = () => {
    setUrl(null);
  };
  //设置
  const [tabStatus, seTabStatus] = useState({
    operationKey: props.location.query.tabStatus ? props.location.query.tabStatus : 'basis',
    tabActiveKey: props.location.query.tabStatus ? props.location.query.tabStatus : 'basis',
  });
  useEffect(() => {
    SetCurrTabKey(tabStatus.tabActiveKey);
  }, [tabStatus])
  const onTabChange = (key) => {
    if (currentGoodsProp === 1) {
      message.info('套餐不能设置配方');
      return;
    }
    seTabStatus({ operationKey: key, tabActiveKey: key });
  };

  const operationTabList = [
    {
      key: 'basis',
      tab: '商品基础信息',
    },
    {
      key: 'goodsbom',
      tab: '商品配方',
    },
    {
      key: 'goodstechnologymaken',
      tab: '商品工艺',
    },
  ];

  const bomcolumns =
    [
      {
        title: '主键',
        dataIndex: 'id',
        key: 'id',
        hideInTable: true,
        hideInSearch: true,
        tip: '规则名称是唯一的 key',
      },
      {
        title: '配方名称',
        key: 'name',
        dataIndex: 'name',
        valueType: 'textarea',
      },
      {
        title: '配方类型',
        dataIndex: 'isMain',
        hideInForm: true,
        valueEnum: {
          false: {
            text: '辅料',
            status: 'Processing',
          },
          true: {
            text: '主料',
            status: 'Success',
          },
        },
      },
      {
        title: '商品属性',
        dataIndex: 'goodsAttributeName',
        valueType: 'textarea',
      },
      {
        title: '操作',
        dataIndex: 'option',
        valueType: 'option',
        render: (_, record) => [
          <a
            key="primary"
            type="primary"
            onClick={() => {
              const hide = message.loading('正在删除');
              try {
                DelGoodsBom(record.id);
                hide();
                message.success('删除成功，即将刷新');
                actionRef.current.reload();
                return true;
              } catch (error) {
                hide();
                message.error('删除失败，请重试');
                actionRef.current.reload();
                return false;
              }

            }}
          >
            删除
          </a>
        ],
      }
    ]

  const contentList = {
    basis: (
      <Card
        title="商品基础信息"
        style={{
          marginBottom: 24,
        }}
        bordered={false}
      >
        <Form
          form={form}
          labelCol={{ span: 4 }}
          wrapperCol={{ span: 6 }}
          layout="horizontal"
          preserve={false}
          initialValues={props.location.query.values}
          onFinish={onFinish}
        >
          <Form.Item name="id" hidden={true}>
            <Input />
          </Form.Item>
          <Form.Item name="code" label="商品编码" hidden={true}   >
            <Input  disabled/>
          </Form.Item>
          <Form.Item name="name" label="商品名称" rules={[{ required: true }]}>
            <Input />
          </Form.Item>
          <Form.Item name="goodsUintId" label="商品单位" rules={[{ required: true }]}>
            <Select>
              {
                goodsUnit == undefined ? '' : (
                  goodsUnit.map((item, index) => {
                    return (
                      <Select.Option index={index} value={item.id} key={item.id}>
                        {item.name}
                      </Select.Option>
                    );
                  })
                )
              }
            </Select>
          </Form.Item>
          <Form.Item name="price" label="商品价格" rules={[{ required: true }]}>
            <InputNumber placeholder="价格" min={0} />
          </Form.Item>
          <Form.Item name="vipPrice" label="会员价格">
            <InputNumber placeholder="会员价" min={0} />
          </Form.Item>
          <Form.Item name="parentTypeID" label="商品大类" rules={[{ required: true }]}>
            <Select>
              {
                goodsBigTypes == undefined ? '' : (
                  goodsBigTypes.map((item, index) => {
                    return (
                      <Select.Option index={index} value={item.id} key={item.id}>
                        {item.name}
                      </Select.Option>
                    );
                  })
                )
              }
            </Select>
          </Form.Item>
          <Form.Item name="goodsTypeId" label="商品小类" rules={[{ required: true }]}>
            <Select>
              {
                goodsTypes == undefined ? '' : (
                  goodsTypes.map((item, index) => {
                    return (
                      <Select.Option index={index} value={item.id} key={item.id}>
                        {item.goodsType_Name}
                      </Select.Option>
                    );
                  })
                )
              }
            </Select>
          </Form.Item>
          
          <Form.Item
            name="goodsAttribute"
            label="商品属性"
            defaultValue={0}
            rules={[{ required: true, message: '请选择商品属性' }]}
          >
            <Select placeholder="请选择商品属性" onChange={(e) => {
              setCurrentGoodsProp(e);
            }}>
              <OptGroup>
                <Select.Option value={0}>单品</Select.Option>
                <Select.Option value={1}>套餐</Select.Option>
              </OptGroup>
            </Select>
          </Form.Item>
         
          <Form.Item
            name="status"
            label="状态"
            defaultValue={0}
            rules={[{ required: true, message: '请选择状态' }]}
          >
            <Select placeholder="请选择状态">
              <OptGroup>
                <Select.Option value={0}>正常</Select.Option>
                <Select.Option value={1}>停用</Select.Option>
              </OptGroup>
            </Select>
          </Form.Item>
          <Form.Item name="foreignKeyRe" label="关联外键" rules={[{ required: false }]}>
          <Input />
        </Form.Item>
        <Form.Item name="defaultMate"  label="默认原料" rules={[{ required: false }]}>
            <Select mode="multiple" allowClear>
              {
                matedata == undefined ? '' : (
                  matedata.map((item, index) => {
                    return (
                      <Select.Option index={index} value={item.id} key={item.id}>
                        {item.name}
                      </Select.Option>
                    );
                  })
                )
              }
            </Select>
          </Form.Item>
          <Form.Item name="remark" label="备注">
            <Input />
          </Form.Item>
          <Form.Item name="design" label="规格" >
            <TextArea  rows={4} />
          </Form.Item>
          <Form.Item name="imgUrl" hidden={true}  >
            <Input />
          </Form.Item>
          <Form.Item name="imgUrl1" label="商品图片">
            <Upload {...uploadProp} showUploadList={false}>
              <div
                style={{
                  position: 'relative',
                  display: 'inline-block',
                  cursor: 'pointer',
                }}
                onMouseEnter={() => setHovered(true)}
                onMouseLeave={() => setHovered(false)}
              >
                {url ? (
                  <>
                    <img
                      src={url}
                      alt=""
                      style={{
                        maxWidth: '100%',
                        maxHeight: '150px',
                        height: 'auto',
                        borderRadius: '4px',
                        transition: 'opacity 0.3s ease',
                        opacity: hovered ? 0.5 : 1,
                        backgroundColor: hovered ? 'rgba(0, 0, 0, 0.5)' : 'transparent',
                      }}
                    />
                    {hovered && (
                      <Button
                        type="link"
                        danger
                        onClick={(event) => {
                          event.stopPropagation();
                          handleDeleteImage();
                        }}
                        icon={<DeleteOutlined />}
                        style={{
                          position: 'absolute',
                          top: '50%',
                          left: '50%',
                          transform: 'translate(-50%, -50%)',
                        }}
                      />
                    )}
                  </>
                ) : (
                  <Button icon={<UploadOutlined />}>上传</Button>
                )}
              </div>
            </Upload>
          </Form.Item>
          <Form.Item label="是否称重" name="isWeigh" valuePropName="checked" initialValue='false' >
            <Switch checkedChildren="是" unCheckedChildren="否" defaultChecked='false' />
          </Form.Item>
          <Form.Item label="是否多属性" name="isAttrubute" valuePropName="checked" initialValue='false'>
            <Switch checkedChildren="是" unCheckedChildren="否" defaultChecked="false" />
          </Form.Item>
          <Form.Item>
            <Button type="primary" htmlType="submit">
              保存
            </Button>
          </Form.Item>
        </Form>
      </Card>
    ),
    goodsbom: (
      <Card
        title="商品配方"
        style={{
          marginBottom: 24,
        }}
        bordered={false}
      >
        <ProTable
          columns={bomcolumns}
          actionRef={actionRef}
          rowKey="id"
          search={false}
          toolBarRender={() => [
            <Button
              type="primary"
              key="primary"
              onClick={async() => {
                if (props.location.query.values?.id == undefined || props.location.query.values?.id == null) {
                  message.info('请先添加商品基础信息!');
                } else {
                  await getbygoodsidattribute(props.location.query.values.id).then((r)=>{
                    setGoodsAttriburteData(r.data);
                  })
                  handleGoodsBomModalVisible(true);
                }
              }}
            >
              <PlusOutlined /> 选择配方
            </Button>,
                 <Button
                 type="primary"
                 key="primary"
                 onClick={ async() => {
                   if (props.location.query.values?.id == undefined || props.location.query.values?.id == null) {
                     message.info('请先添加商品基础信息!');
                   } else {
                    await getbygoodsidattribute(props.location.query.values.id).then((r)=>{
                      setGoodsAttriburteData(r.data);
                    })
                    setHandleCreateoodsBomModalVisible(true);
                   }
                   //
                 }}
               >
                 <PlusOutlined /> 新建配方
               </Button>,
          ]}
          request={async (params) => {
            if (props.location.query.values.id == undefined || props.location.query.values.id == null) {

            } else {
              params.GoodsId = props.location.query.values.id;
              var total = 0;
              const msg = await GetGoodsBom(params);
              return {
                data: msg.data.data,
                success: true,
                total: total,
              };
            }

          }}
          rowSelection={{
            onChange: (_, selectedRows) => setSelectedRows(selectedRows),
          }}

        />
        <GoodsbomFrom
          onFinish={async (value) => {
            console.log("value", value);
            value['GoodsId'] = props.location.query.values.id;
            var success = false;
            success = await AddBomApi(value);
            if (success) {
              handleGoodsBomModalVisible(false);
            }
            actionRef.current.reload();
          }}
          onCancel={() => {
            handleGoodsBomModalVisible(false);
          }}
          goodsAttriburteData={goodsAttriburteData}
          createModalVisible={setGoodsBomModalVisible}
        />
        <CreateBom handleCreateoodsBomModalVisible={handleCreateoodsBomModalVisible}  
        onFinish={async (value) => {
          value.goodsId=props.location.query.values.id;
          console.log(value)
          await addgoodsbomattribute(value).then((r)=>{
            console.log(r)
            if(r.data){
              message.success("添加成功")
              setHandleCreateoodsBomModalVisible(false);
            }else{
              message.error("添加失败")
            }
            actionRef.current.reload();
          })
        }}
        goodsid={props.location.query.values?.id}
        goodsname={props.location.query.values?.name}
        goodsAttriburteData={goodsAttriburteData}
        matedata={matedata}
        bomtype={bomtype}
        defaultmatedata={props.location.query.values?.defaultMate}
        onCancel={() => {
          setHandleCreateoodsBomModalVisible(false);
        }}
        />
      </Card>
     
    ),
    goodstechnologymaken:(
      <Card  title="商品工艺" style={{ marginBottom: 24}} bordered={false}>
      <GoodsTechnologyMaken goodsid={props.location.query.values?.id}></GoodsTechnologyMaken>
    </Card>
    ),
  };

  //初始化
  useEffect(() => {
    function initGoodsType() {
      goodsType({ current: 1, status: 0, pageSize: 1000 }).then((r) => {
        var arr = r.data.data;
        arr.forEach((element) => {
          element.text = element.goodsType_Name;
        });
        if(arr.length==0){
          setGoodsTypes([{id:'-1',goodsType_Name:'默认分类'}]);
         }else{
          setGoodsTypes(arr);
         }

     
      });
    }
    function initGoodsBigType() {
      goodsbigType({ current: 1, status: 0, pageSize: 1000 }).then((r) => {
        var arr = r.data.data;
        arr.forEach((element) => {
          element.text = element.name;
        });
       if(arr.length==0){
        setGoodsBigTypes([{id:'-1',name:'默认分类'}]);
       }else{
        setGoodsBigTypes(arr);
       }
      });
    }
    function initGoodsUnit() {
      unitList('{"current":1,"pageSize":200}').then((r) => {
        var arr = r.data.data;
        if(arr.length==0){
          setGoodsUnit([{
            id:"-1",
            name:"默认单位"
          }]);
        }else{
          setGoodsUnit(arr);
        }
      });
    }
    getbomtypepage({ current: 1, pagesize: 1000,status:"0" }).then((r) => {
      setBomtype(r.data.data);
  })
   getproductpage({ current: 1, pagesize: 1000}).then((r) => {
    setMatedata(r.data.data);
  });
    initGoodsUnit();
    initGoodsType();
    initGoodsBigType();
  }, []);

  return (
    <PageContainer
    host header={{
      title: [<a  key="back"
      onClick={() => {
        history.push({
          pathname: '/goods/newgoods',
        });
      }}><ArrowLeftOutlined />返回</a>],
      breadcrumb: {},
    }}
      title={props.location.query.isAdd ? '商品新增' : '详情'}
      tabActiveKey={currTabKey}
      onTabChange={onTabChange}
      tabList={operationTabList}
    >
      {contentList[tabStatus.operationKey]}
    </PageContainer>
  );
};

export default Advanced;
